<?php
class Codeviewer_model extends CI_Model {

	function __construct(){
		$this->load->database();
	}

	function showFile($filename, $lang, $interestingrows = array()) {
		$output = "";
		$output .= '<div class="editorinfo">'.$lang.'&nbsp;&nbsp;&nbsp;&nbsp;'.$filename.'</div>';
		$output .= '<div id="ace_'.str_replace(".", "", $filename).'" class="ace">';
		$handle = @fopen($filename, "r");
		if ($handle) {

			while (($buffer = fgets($handle, 4096)) !== false) {

				$buffer = str_replace("&", "&amp;", $buffer);
				$buffer = str_replace("<", "&lt;", $buffer);
				$buffer = str_replace(">", "&gt;", $buffer);

				$output .= $buffer;
			}
			if (!feof($handle)) {
				$output .= "Error: unexpected fgets() fail\n";
			}
			fclose($handle);
		}
		$output .= '</div>';

		$output .=  '<script type="text/javascript">
		var Range = require("ace/range").Range;
		var editor = ace.edit("ace_'.str_replace(".", "", $filename).'");
		editor.setTheme("ace/theme/merbivore");
		editor.getSession().setMode("ace/mode/'.$lang.'");
		editor.setReadOnly(true);
		editor.setShowPrintMargin(false);
		editor.setDisplayIndentGuides(false);
		editor.setHighlightSelectedWord(true);
		lines = editor.getSession().getLength();
		$("#ace_'.str_replace(".", "", $filename).'").height(Math.min(500,lines*16));
		aceeditors.push("ace_'.str_replace(".", "", $filename).'");';
		for($i = 0; $i < count($interestingrows); $i++) {
			$output .= 'editor.getSession().addMarker(new Range('.$interestingrows[$i][0].', 0, '
				.$interestingrows[$i][1].', Number.POSITIVE_INFINITY), "interesting", "text",false);';
		}
		$output .= '</script>';

		return $output;
	}

	function getFiles($course, $example, $page){
		$files = array();
		if ($handle = opendir("../courses/".$course."/". $example."/".$page."/")) {
			while (false !== ($entry = readdir($handle))) {
				if($entry == "." || $entry == "..") continue;
				$files[] = "../courses/".$course."/". $example."/".$page."/".$entry;
			}
		}

		return $files;
	}

	function getDoc($cid, $example, $page){
		$this->db->select('documentation');
		$query = $this->db->get_where('pages', array('cid' => $cid, 'example' => $example, 'page' => $page));
		$result = $query->result();
		return $result[0]->documentation;
	}

}
